#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""main - Main module that starts the game."""

##Panda3D imports##
from direct.fsm.FSM import FSM
from direct.showbase.DirectObject import DirectObject
from direct.showbase.Transitions import Transitions
##Local imports##
from src.engine import Engine
from src.audio import Audio
from src.mainmenu import MainMenu
from src.world import World


class Main(object, FSM, DirectObject):

    def __init__(self):
        FSM.__init__(self, 'MainFSM')
        Engine.start()
        Audio.loadSounds()
        Audio.loadMusic()
        self.request('Menu')
        self.accept('menu', self.request, ['Menu'])

    def run(self):
        Engine.base.run()

    def enterMenu(self):
        self.accept('StartGame', self.request, ['Game'])
        self.mainMenu = MainMenu()
        Audio.playTrack('Menu Music')

    def exitMenu(self):
        self.mainMenu.destroy()
        Audio.stopTrack()

    def enterGame(self):
        self.world = World()

app = Main()
app.run()

